/*****************************************************************
JADE - Java Agent DEvelopment Framework is a framework to develop 
multi-agent systems in compliance with the FIPA specifications.
Copyright (C) 2000 CSELT S.p.A. 

GNU Lesser General Public License

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, 
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.
*****************************************************************/

package AgentiMobili;

import java.io.IOException;

import Ontologia.*;
import alice.tuprolog.MalformedGoalException;
import alice.tuprolog.NoSolutionException;
import alice.tuprolog.SolveInfo;
import alice.tuprolog.Term;
import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;







class BuildingBehaviour extends SimpleBehaviour
{
	private int step=0;
	
	
	
	
	BuildingBehaviour(Agent a)
	{
		super(a);
	}

	public boolean done()
	{
		return false;
	}

	public void action()
	{
		
		//comportamento complesso ...
		
		
		if(((MobileAgent) myAgent).building && ((MobileAgent)myAgent).cnt%3==0){
			
			switch (step) {
			case 0:
            this.FirstStep();
			step++;
			break;
			case 1:
			this.SecondStep();	
			step++;
			break;
			case 2:
			this.ThirdStep();	
			
			break;
			}
			
			return;
			
		}
		
		else{ block(2000);
	    return;
		}
		
		
		

}
	

	void FirstStep(){
		
		Tile t= ((MobileAgent)myAgent).getBuildingTile();
		ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
		try {
			msg.setContentObject(t);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        msg.setOntology(TileOntology.getInstance().getName());
	    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
        myAgent.send(msg);
        //fino a che  attivo questo behaviour solo questo behaviour risponde
        

		return;	
		
	}
	

	void SecondStep(){
		
		Action t= new Action("BuildHouse" ,((MobileAgent)myAgent).getBuildingTile());
		ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
		try {
			msg.setContentObject(t);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        msg.setOntology(TileOntology.getInstance().getName());
	    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
        myAgent.send(msg);
		
		
		
		
		return;	
		
	}
	
void ThirdStep(){
		
		Tile t= new Tile(((MobileAgent)myAgent).getBuildingTile().getTileX()-1,((MobileAgent)myAgent).getBuildingTile().getTileY()-1);
		ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
		try {
			msg.setContentObject(t);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        msg.setOntology(TileOntology.getInstance().getName());
	    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
        myAgent.send(msg);
		((MobileAgent)myAgent).building=false;
		//per la prossima
		step=0;
		((MobileAgent)myAgent).treeCounter=0;
		
		return;	
		
	}
	
	
	
	
	

}