/*****************************************************************
JADE - Java Agent DEvelopment Framework is a framework to develop 
multi-agent systems in compliance with the FIPA specifications.
Copyright (C) 2000 CSELT S.p.A. 

GNU Lesser General Public License

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, 
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.
*****************************************************************/

package AgentiMobili;

import java.io.IOException;

import Ontologia.*;
import alice.tuprolog.MalformedGoalException;
import alice.tuprolog.NoSolutionException;
import alice.tuprolog.SolveInfo;
import alice.tuprolog.Term;
import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;


/**
The behaviour uses two resources, in particular the counter cnt
and the flag cntEnabled, of the agent object. 
It increments by one its value, displays it, blocks 
for two seconds, and repeats forever. 
@author Giovanni Caire - CSELT S.p.A
@version $Date: 2002/07/16 09:20:11 $ $Revision: 2.1 $
*/

class CounterBehaviour extends SimpleBehaviour
{
	CounterBehaviour(Agent a)
	{
		super(a);
	}

	public boolean done()
	{
		return false;
	}

	public void action()
	{
		// If counting is enabled, print current number and increment counter
		if ( ((MobileAgent) myAgent).cntEnabled )
		{
			((MobileAgent) myAgent).cnt++;
			((MobileAgent) myAgent).displayCounter();

		}
		 
	    
		
		Tile t= ((MobileAgent)myAgent).getActualTile();
		
		/*
		 * Cerca una casella che non conosce.&& ((MobileAgent) myAgent).cnt%3==0
		 */
		if(((MobileAgent)myAgent).getActualWorldId()!=null && ((MobileAgent) myAgent).cnt%3==0 && !((MobileAgent) myAgent).building)
		{
			int i=0;
			boolean success=true;
			boolean choose=false;
			
			while(success){
				int random = (int)(4*Math.random()-0.001);
				//spreco cicli, ma scelgo a caso.
			i++;
				switch(random){
			
			case 0:
				try {
					//"tile("+ (t.getTileX()+1)+  ","+ t.getTileY()+ ")" 
					SolveInfo info = ((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX()+1)+  ","+ t.getTileY()+ ",free)." );
					success= info.isSuccess();
					
					//dovesse essere un bound non interrogare mai lo universe manager sullo stato della casella.
					if((!success && !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX()+1)+  ","+ (t.getTileY())+ ",bound)." ).isSuccess()
					&& !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX()+1)+  ","+ (t.getTileY())+ ",notexplorable)." ).isSuccess())		
					){
					    Tile nTile=	new Tile(t.getTileX()+1,t.getTileY());
						ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
						msg.setContentObject(nTile);
				        msg.setOntology(TileOntology.getInstance().getName());
					    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
				        myAgent.send(msg);
				        
				        block(2000);
	                    return;
					}
					else if(choose && success){
						
						 Tile nTile=	new Tile(t.getTileX()+1,t.getTileY());
							ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
							msg.setContentObject(nTile);
					        msg.setOntology(TileOntology.getInstance().getName());
						    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
					        myAgent.send(msg);
					        
					        block(2000);
		                    return;
						
						
						
					}
					
					
					//se non ritorna incremento i
					random++;
					
				    
				    } catch (MalformedGoalException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
			
			case 1:
				try {
					//"tile("+ t.getTileX()+  ","+ (t.getTileY()+1)+ ")"
					SolveInfo info = ((MobileAgent) myAgent).getEngine().solve("tile("+ t.getTileX()+  ","+ (t.getTileY()+1)+ ",free).");
				 	 success= info.isSuccess();
				     
				     if((!success && !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX())+  ","+ (t.getTileY()+1)+ ",bound)." ).isSuccess()
				    	&& !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX())+  ","+ (t.getTileY()+1)+ ",notexplorable)." ).isSuccess()	 
				        )){
				    	 ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
				    	  Tile nTile=	new Tile(t.getTileX(),t.getTileY()+1);
				    	   msg.setContentObject(nTile);
					        msg.setOntology(TileOntology.getInstance().getName());
						    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
					        myAgent.send(msg);	
					        
					        block(2000);

							return;
						}
				     else if(choose && success){
				    	 ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
				    	  Tile nTile=	new Tile(t.getTileX(),t.getTileY()+1);
				    	   msg.setContentObject(nTile);
					        msg.setOntology(TileOntology.getInstance().getName());
						    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
					        myAgent.send(msg);	
					        
					        block(2000);

							return;
				    	 
				    	 
				    	 
				     }
				     
				
				   } catch (MalformedGoalException e) {
				     // TODO Auto-generated catch block
				     e.printStackTrace();
			        } catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			random++;
			case 2:
				try {
					//"Tile("+ (t.getTileX()-1)+  ","+ t.getTileY()+ ")"
				   SolveInfo info= ((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX()-1)+  ","+ t.getTileY()+ ",free).");
				   success= info.isSuccess();
					
					//dovesse essere un bound non interrogare mai lo universe manager sullo stato della casella.
					
				   if((!success && !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX()-1)+  ","+ (t.getTileY())+ ",bound)." ).isSuccess()
						  && !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX()-1)+  ","+ (t.getTileY())+ ",notexplorable)." ).isSuccess()
				   )){
				    	 ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
				    	 
				    	 msg.setContentObject(new Tile(t.getTileX()-1,t.getTileY()));
					        msg.setOntology(TileOntology.getInstance().getName());
						    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
					        myAgent.send(msg);
					       
					        block(2000);

							return;
						}
				   else if(choose && success){
					   ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
				    	 
				    	 msg.setContentObject(new Tile(t.getTileX()-1,t.getTileY()));
					        msg.setOntology(TileOntology.getInstance().getName());
						    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
					        myAgent.send(msg);
					       
					        block(2000);

							return;
					   
					   
					   
					   
				   }
				   
				   
				   
				
				   
				  } catch (MalformedGoalException e) {
				     // TODO Auto-generated catch block
				     e.printStackTrace();
			        } catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				random++;
			
			case 3:	
				try {
					//"Tile("+ t.getTileX()+  ","+ (t.getTileY()-1)+ ")"
				   SolveInfo info = ((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX())+  ","+ (t.getTileY()-1)+ ",free).");
				   success= info.isSuccess();
					
					//dovesse essere un bound non interrogare mai lo universe manager sullo stato della casella.
					
				   
				   
				   if(choose || (!success && !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX())+  ","+ (t.getTileY()-1)+ ",bound)." ).isSuccess()
						&&  !((MobileAgent) myAgent).getEngine().solve("tile("+ (t.getTileX())+  ","+ (t.getTileY()-1)+ ",notexplorable)." ).isSuccess()   
				   )
				   ){
	                	ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
	                	 
	                	msg.setContentObject(new Tile(t.getTileX(),t.getTileY()-1));
				        msg.setOntology(TileOntology.getInstance().getName());
					    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
				        myAgent.send(msg);
				       
				        block(2000);

						return;
					}
				   else if(choose && success){
					   
					   ACLMessage msg= new ACLMessage(ACLMessage.QUERY_IF);
	                	 
	                	msg.setContentObject(new Tile(t.getTileX(),t.getTileY()-1));
				        msg.setOntology(TileOntology.getInstance().getName());
					    msg.addReceiver(((MobileAgent)myAgent).getActualWorldId());
				        myAgent.send(msg);
				       
				        block(2000);

						return;
					   
					    }
	                
	               
	                
				    } catch (MalformedGoalException e) {
				     // TODO Auto-generated catch block
				     e.printStackTrace();
			        } catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				
			  default :   if(i>=4){ choose = true;      }
			
			}	
				
				
				
				
				
			}
			
			
			
			
		}
		
//		 Block the behaviour for 2 seconds
		// if ActualWorldId is null...
		
		block(2000);

		return;	
			
			
			
}

}
