/*
 * Created on 15-feb-2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Ontologia;
import jade.content.onto.*;
import jade.content.schema.*;

public class TileOntology extends Ontology{
	
	
	
//	 The name identifying this ontology
	public static final String ONTOLOGY_NAME = "TileOntology";
//	 VOCABULARY
	public static final String Tile = "Tile";
	public static final String TileX = "TileX";
	public static final String TileY = "TileY";
	
	public static final String Explorable = "Explorable";
	public static final String Explorable_X = "Explorable_X";
	public static final String Explorable_Y = "Explorable_Y";
	public static final String ExplorableState = "ExplorableState";
	public static final String Type = "Type";
	public static final String Action = "Action";
	public static final String ActionOn_X = "ActionOn_X";
	public static final String ActionOn_Y = "ActionOn_Y";
	public static final String ActionType = "ActionType";
//	 The singleton instance of this ontology
	private static Ontology theInstance = new TileOntology();
//	 This is the method to access the singleton music shop ontology object
	public static Ontology getInstance() {
	return theInstance;
	}
//	 Private constructor
	private TileOntology() {
//	 The music shop ontology extends the basic ontology
	super(ONTOLOGY_NAME, BasicOntology.getInstance());
	try {
	add(new ConceptSchema(Tile), Tile.class);
	add(new PredicateSchema(Explorable), Explorable.class);
	add(new AgentActionSchema(Action), Action.class);
//	 Structure of the schema for the Item concept
	ConceptSchema cs = (ConceptSchema) getSchema(Tile);
	cs.add(TileX, (PrimitiveSchema) getSchema(BasicOntology.INTEGER),
	ObjectSchema.MANDATORY); // The serial-number slot is optional and
	cs.add(TileY, (PrimitiveSchema) getSchema(BasicOntology.INTEGER),
			ObjectSchema.MANDATORY); // The serial-number slot is optional and
	
	
//	 Structure of the schema for the Owns predicate
	PredicateSchema ps = (PredicateSchema) getSchema(Explorable);
	ps.add(Explorable_X, (PrimitiveSchema) getSchema(BasicOntology.INTEGER));
	ps.add(Explorable_Y, (PrimitiveSchema) getSchema(BasicOntology.INTEGER));
	ps.add(ExplorableState, (PrimitiveSchema) getSchema(BasicOntology.BOOLEAN));
	ps.add(Type, (PrimitiveSchema) getSchema(BasicOntology.STRING));
	//	 Structure of the schema for the Sell agent action
	AgentActionSchema as = (AgentActionSchema) getSchema(Action);
	as.add(ActionOn_X, (PrimitiveSchema) getSchema(BasicOntology.INTEGER));
	as.add(ActionOn_Y, (PrimitiveSchema) getSchema(BasicOntology.INTEGER));
	as.add(ActionType, (PrimitiveSchema) getSchema(BasicOntology.STRING));
	}
	catch (OntologyException oe) {
	oe.printStackTrace();
	}
	}
	
	
	
	
	
}
